<template>
  <div class="mainMenu">
    <!-- <button v-on:click="connect()" class="btn"><i><font-awesome-icon :icon="['far', 'save']"/></i></button> -->
    <button v-on:click="connect()" class="btn"><font-awesome-icon :icon="['fas', 'link']" size="2x"/></button>
    <button v-on:click="saveCode()" class="btn"><font-awesome-icon :icon="['fas', 'save']" size="2x"/></button>
    <button v-on:click="connect()" class="btn"><font-awesome-icon :icon="['fas', 'undo']" size="2x"/></button>
    <button v-on:click="connect()" class="btn"><font-awesome-icon :icon="['fas', 'redo']" size="2x"/></button>
    <RadialMenu id="menuRadial"></RadialMenu>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, onMounted } from 'vue'
import BlocklyLang from 'blockly/lua'
import Blockly from 'blockly'
import { FontAwesomeIcon } from '@fortawesome/vue-fontawesome'
import { library } from '@fortawesome/fontawesome-svg-core'
import { faLink, faSave, faUndo, faRedo } from '@fortawesome/free-solid-svg-icons'
import RadialMenu from './RadialMenu.vue'

declare var Android: any // eslint-disable-line

library.add(faLink, faSave, faUndo, faRedo)

export default defineComponent({
  components: {
    'font-awesome-icon': FontAwesomeIcon,
    RadialMenu
  },

  props: ['parentWorkspace'],
  setup (props) {
    const saveCode = (): void => {
      console.log('clicked')
    }

    const getXMLBlockly = (): string => {
      const xml = Blockly.Xml.workspaceToDom(props.parentWorkspace)
      return Blockly.Xml.domToText(xml)
    }

    const getCodeLua = (): string => {
      (BlocklyLang as any).INFINITE_LOOP_TRAP = null // eslint-disable-line
      return (BlocklyLang as any).workspaceToCode(props.parentWorkspace) // eslint-disable-line
    }

    const connect = (): void => {
      // console.log(getCodeLua())
      // console.log(getXMLBlockly())
      Android.startConnectActivity(getCodeLua(), getXMLBlockly()) // eslint-disable-line
    }

    return {
      saveCode,
      getXMLBlockly,
      getCodeLua,
      connect
    }
  }
})
</script>

<style scoped>
.mainMenu {
  width: 100%;
}

.btn {
  display: inline;
  background-color: darkslategray;
  border-radius: 50%;
  border-color: darkslategray;
  color: white;
  padding: 16px 16px;
  /* font-size: 22px;*/
  cursor: pointer;
}

.btn:hover {
  background-color: blueviolet;
}

</style>
